#include <hidef.h>      /* common defines and macros */
#include <mc9s12a64.h>     /* derivative information */

#include "pll.h"
#include "timer.h"
#include "sci.h"

#pragma LINK_INFO DERIVATIVE "mc9s12a64"

void main(void) {
   char c;

   PLL_Init();
   Timer_Init(0,1);
   SCI_Init(0, 38400); // GPS module
   SCI_Init(1, 115200); // LCD / PC connection
   
   EnableInterrupts;
   
   DDRT |= 0xFF;     // PortT bits 0-7 are output
   
   PTT = 0;
      
   for(;;) 
   {
      PTT ^= 0x01;
      c = SCI_InChar(0);		          
      SCI_OutChar(1, c);           
   }
}
