/******************************* adc.c *******************************/

// Functions for analog to digital conversion

#include <mc9s12c32.h>
#include "adc.h"


// Initialize ATD subsystem
void ADC_Init(void)
{
   ATDCTL2 = 0x80; // enable ADC   
   ATDCTL3 = 0x08; // conversion length of 1	   
   ATDCTL4 = 0x05; // set sample clock to 2MHz which is max	    
}


// Returns a 10bit right justified value for the input channel specified
// in a 16bit integer
unsigned short ADC_In(unsigned char channel)
{ 
   ATDCTL5 = 0x80 | channel;   // start the conversion sequence
   while(!(ATDSTAT0 & 0x80));  // wait for the conversion to complete 
   return ATDDR0; 
}

