

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BLOCK_SIZE 512


int main(int argc, char* argv[])
{
   int i=0, j=0, blocknum, address, n, len;
   unsigned char b;
   char *file, *search;
   FILE *fp;

   if (argc != 4) {
      printf("Usage: %s SD_dump mode blocknum|search\n", argv[0]);
      return 0;
   }

   file = argv[1];

   if (argv[2][0] == '0') {
      // default block printing with mode="0"

      blocknum = atoi(argv[3]);
      address = blocknum * BLOCK_SIZE;

      printf("\nBlock %d:\n", blocknum);
      if ((fp = fopen(file, "rb"))) {
         fseek(fp, address, SEEK_SET);
         for (i=1; i<=BLOCK_SIZE; i++) {
            // read in a byte and print it as hex
            fread(&b, 1, 1, fp);
            printf("%02X", b);
         
            // add appropriate spacing
            if ( (i%16) == 0 )
               printf("\n");
            else if ( (i%8) == 0 )
               printf("  ");           
            else
               printf(" ");            
         }
         fclose(fp);
      }
      else {
         printf("Could not open: %s\n", file);
      }   
   }
   else {
      // search
      search = argv[3];
      len = strlen(search);
      
      // search the file   
      if ((fp = fopen(file, "rb"))) {      
         while (!feof(fp)) {  
            n=fread(&b, 1, 1, fp);
            //if (i<512) printf("%c", b);
            //if (b == 0xC1) printf("0xC1 found at: %d\n", search, i);
            if (b == search[j]) j++;
            else j=0;
            if (j==len) {
               address = i-j+1;
               blocknum = address/BLOCK_SIZE;
               printf("%s found at byte: %d, block: %d\n", search, address, blocknum);
               break;
            }
            i++;
         }
         fclose(fp);
      }
      else {
         printf("Could not open: %s\n", file);
      }
   }

	return 0;
}
